> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.shimi.cash/api-reference/shimi-api/airtime-data-bills-vtu/purchase-cable-tv/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.shimi.cash/_mcp/server. # Purchase Cable TV POST https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv Content-Type: application/json Pays a cable TV subscription for a previously verified smartcard. **Body (JSON):** | Field | Type | Rules | | --------------------- | ------- | ----------------------------------------------------------------------------------------------------------- | | `idempotencyKey` | string | required, 4–250 chars | | `meterVerificationId` | string | required; unused ID from **Verify Entity** for a Cable TV category | | `productId` | string | required; a package (`categoryProductId`) from the same category | | `cardNumber` | string | required, 4–250; the smartcard/IUC number — send the **same** number you verified (it is not cross-checked) | | `settlementId` | integer | required | The package price is charged; no `amount` field. The *duplicate* response for this endpoint has no `message` field. **Purchase outcomes** (shared flow): * **200** `data.status: "SUCCESS"` — delivered. * **200** `data.status: "PENDING"` with message `... purchase is being confirmed. Do not retry; check the transaction status.` — provider outcome unknown; you have been debited and **not** refunded. Poll **Fetch Single VTU Transaction**; do not resend. * **400** `... purchase failed. Your balance has been refunded.` — provider definitively rejected; safe to retry with a **new** `idempotencyKey`. * **409** `Duplicate request in flight` — another request with the same `idempotencyKey` is being processed. * **200** `Duplicate request — returning existing transaction` — the `idempotencyKey` was already used; the original transaction is returned and nothing is charged. Your settlement balance must be **strictly greater** than the amount (`balance <= amount` is rejected as insufficient). **Error format:** body validation failures (Joi) return `{ "status": "error", "message": "Validation error", "details": [ ... ] }`; all other errors return `{ "success": false, "message": "..." }`. Money fields (`amount`, `fee`) are Prisma Decimals and are serialized as **strings** (e.g. `"1000"`). Reference: https://docs.shimi.cash/api-reference/shimi-api/airtime-data-bills-vtu/purchase-cable-tv ## Authentication - `Authorization` header (bearer token, required) — Access token from Generate Access Token (valid 15 minutes). ## Request ### Body (application/json) This endpoint expects an object. - `idempotencyKey` (string, optional) - `meterVerificationId` (string, optional) - `productId` (string, optional) - `settlementId` (integer, optional) - `cardNumber` (string, optional) ## Response ### 200 Success / Pending (being confirmed) / Duplicate (existing transaction) - `success` (boolean, optional) - `data` (VtuPurchaseCableTvPostResponsesContentApplicationJsonSchemaData, optional) - `message` (string, optional) ## Errors ### 400 Bad Request Error Failed (refunded) / Insufficient balance / Verification used / Validation error / Invalid product - `success` (boolean, optional) - `message` (string, optional) - `status` (string, optional) - `details` (list of string, optional) ### 401 Unauthorized Error Unauthorized - `message` (string, optional) ### 403 Forbidden Error Invalid or expired access token / KYB not approved / Account deactivated - `message` (string, optional) - `code` (string, optional) - `kybStatus` (string, optional) ### 409 Conflict Error Conflict - `success` (boolean, optional) - `message` (string, optional) ## Types ### VtuPurchaseCableTvPostResponsesContentApplicationJsonSchemaData - `transactionId` (string, optional) - `status` (string, optional) - `type` (string, optional) - `amount` (string, optional) - `createdAt` (string, optional) ## Examples ### 200 Success **Response** ```json { "success": true, "data": { "transactionId": "cm2z9h1j20014vtx9mn01op2", "status": "SUCCESS", "type": "CABLE_TV", "amount": "19000", "createdAt": "2026-10-04T10:22:31.418Z" } } ``` **SDK Code** ```python 200 Success import requests url = "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" headers = {"Authorization": "Bearer "} response = requests.post(url, headers=headers) print(response.json()) ``` ```javascript 200 Success const url = 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv'; const options = {method: 'POST', headers: {Authorization: 'Bearer '}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go 200 Success package main import ( "fmt" "net/http" "io" ) func main() { url := "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" req, _ := http.NewRequest("POST", url, nil) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby 200 Success require 'uri' require 'net/http' url = URI("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java 200 Success import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") .header("Authorization", "Bearer ") .asString(); ``` ```php 200 Success request('POST', 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv', [ 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp 200 Success using RestSharp; var client = new RestClient("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift 200 Success import Foundation let headers = ["Authorization": "Bearer "] let request = NSMutableURLRequest(url: NSURL(string: "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### 200 Pending (being confirmed) **Response** ```json { "success": true, "data": { "transactionId": "cm2z9h1j20014vtx9mn01op2", "status": "PENDING", "type": "CABLE_TV", "amount": "19000", "createdAt": "2026-10-04T10:22:31.418Z" }, "message": "Cable TV purchase is being confirmed. Do not retry; check the transaction status." } ``` **SDK Code** ```python 200 Pending (being confirmed) import requests url = "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" headers = {"Authorization": "Bearer "} response = requests.post(url, headers=headers) print(response.json()) ``` ```javascript 200 Pending (being confirmed) const url = 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv'; const options = {method: 'POST', headers: {Authorization: 'Bearer '}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go 200 Pending (being confirmed) package main import ( "fmt" "net/http" "io" ) func main() { url := "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" req, _ := http.NewRequest("POST", url, nil) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby 200 Pending (being confirmed) require 'uri' require 'net/http' url = URI("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java 200 Pending (being confirmed) import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") .header("Authorization", "Bearer ") .asString(); ``` ```php 200 Pending (being confirmed) request('POST', 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv', [ 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp 200 Pending (being confirmed) using RestSharp; var client = new RestClient("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift 200 Pending (being confirmed) import Foundation let headers = ["Authorization": "Bearer "] let request = NSMutableURLRequest(url: NSURL(string: "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### 200 Duplicate (existing transaction) **Response** ```json { "success": true, "data": { "transactionId": "cm2z9h1j20014vtx9mn01op2", "status": "SUCCESS", "type": "CABLE_TV", "amount": "19000", "createdAt": "2026-10-04T10:22:31.418Z" } } ``` **SDK Code** ```python 200 Duplicate (existing transaction) import requests url = "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" headers = {"Authorization": "Bearer "} response = requests.post(url, headers=headers) print(response.json()) ``` ```javascript 200 Duplicate (existing transaction) const url = 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv'; const options = {method: 'POST', headers: {Authorization: 'Bearer '}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go 200 Duplicate (existing transaction) package main import ( "fmt" "net/http" "io" ) func main() { url := "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" req, _ := http.NewRequest("POST", url, nil) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby 200 Duplicate (existing transaction) require 'uri' require 'net/http' url = URI("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java 200 Duplicate (existing transaction) import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") .header("Authorization", "Bearer ") .asString(); ``` ```php 200 Duplicate (existing transaction) request('POST', 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv', [ 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp 200 Duplicate (existing transaction) using RestSharp; var client = new RestClient("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift 200 Duplicate (existing transaction) import Foundation let headers = ["Authorization": "Bearer "] let request = NSMutableURLRequest(url: NSURL(string: "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### Airtime, Data & Bills (VTU)_purchaseCableTV_example **Request** ```json { "idempotencyKey": "{{$guid}}", "meterVerificationId": "{{meter_verification_id}}", "productId": "{{product_id}}", "settlementId": 1, "cardNumber": "7034567812" } ``` **Response** ```json { "success": true, "data": { "transactionId": "cm2z9h1j20014vtx9mn01op2", "status": "SUCCESS", "type": "CABLE_TV", "amount": "19000", "createdAt": "2026-10-04T10:22:31.418Z" } } ``` **SDK Code** ```python Airtime, Data & Bills (VTU)_purchaseCableTV_example import requests url = "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" payload = { "idempotencyKey": "{{$guid}}", "meterVerificationId": "{{meter_verification_id}}", "productId": "{{product_id}}", "settlementId": 1, "cardNumber": "7034567812" } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript Airtime, Data & Bills (VTU)_purchaseCableTV_example const url = 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"idempotencyKey":"{{$guid}}","meterVerificationId":"{{meter_verification_id}}","productId":"{{product_id}}","settlementId":1,"cardNumber":"7034567812"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Airtime, Data & Bills (VTU)_purchaseCableTV_example package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv" payload := strings.NewReader("{\n \"idempotencyKey\": \"{{$guid}}\",\n \"meterVerificationId\": \"{{meter_verification_id}}\",\n \"productId\": \"{{product_id}}\",\n \"settlementId\": 1,\n \"cardNumber\": \"7034567812\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Airtime, Data & Bills (VTU)_purchaseCableTV_example require 'uri' require 'net/http' url = URI("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"idempotencyKey\": \"{{$guid}}\",\n \"meterVerificationId\": \"{{meter_verification_id}}\",\n \"productId\": \"{{product_id}}\",\n \"settlementId\": 1,\n \"cardNumber\": \"7034567812\"\n}" response = http.request(request) puts response.read_body ``` ```java Airtime, Data & Bills (VTU)_purchaseCableTV_example import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"idempotencyKey\": \"{{$guid}}\",\n \"meterVerificationId\": \"{{meter_verification_id}}\",\n \"productId\": \"{{product_id}}\",\n \"settlementId\": 1,\n \"cardNumber\": \"7034567812\"\n}") .asString(); ``` ```php Airtime, Data & Bills (VTU)_purchaseCableTV_example request('POST', 'https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv', [ 'body' => '{ "idempotencyKey": "{{$guid}}", "meterVerificationId": "{{meter_verification_id}}", "productId": "{{product_id}}", "settlementId": 1, "cardNumber": "7034567812" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp Airtime, Data & Bills (VTU)_purchaseCableTV_example using RestSharp; var client = new RestClient("https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"idempotencyKey\": \"{{$guid}}\",\n \"meterVerificationId\": \"{{meter_verification_id}}\",\n \"productId\": \"{{product_id}}\",\n \"settlementId\": 1,\n \"cardNumber\": \"7034567812\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Airtime, Data & Bills (VTU)_purchaseCableTV_example import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "idempotencyKey": "{{$guid}}", "meterVerificationId": "{{meter_verification_id}}", "productId": "{{product_id}}", "settlementId": 1, "cardNumber": "7034567812" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://shimi-waas-api-9493532b9281.herokuapp.com/api/v1/vtu/purchase-cable-tv")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```